head	1.6;
access;
symbols;
locks
	bilbo:1.6; strict;
comment	@ * @;


1.6
date	2004.01.29.00.51.48;	author bilbo;	state Exp;
branches;
next	1.5;

1.5
date	2004.01.14.22.17.01;	author bilbo;	state Exp;
branches;
next	1.4;

1.4
date	2004.01.14.22.16.49;	author bilbo;	state Exp;
branches;
next	1.3;

1.3
date	2004.01.06.02.17.30;	author bilbo;	state Exp;
branches;
next	1.2;

1.2
date	2004.01.04.22.51.59;	author bilbo;	state Exp;
branches;
next	1.1;

1.1
date	2003.12.23.19.43.36;	author bilbo;	state Exp;
branches;
next	;


desc
@@


1.6
log
@*** empty log message ***
@
text
@#include "config.h"
#include "cfg_file.h"
#include <pthread.h>
#include <stdio.h>
#include <string.h>
#include "compat.h"

config *active; //aktivni konfigurace [EXT]
char *configfile;//jmeno aktualniho konfiguracniho souboru [EXT]

/** nahraje do stromu vsechny radky ze souboru krome komentaru.
 Pripousti se, ze soubor neexistuje */
tree *loadlist(char *filename) {
 int list_size;//velikost
 char *list_data;//nacteno v pameti
 char *list_line;//Vyparsovana radka
 text_token list;
 tree *t=NULL;
 debug_prin\n",filename);
 list_size=loadfile((void **)&list_data,filename);
 if (!list_data) return NULL;
 debug_printf("%s loading\n",filename);

 list=token_create(list_data,list_size);
 while((list_line=token_readline(&list))) {
  debug_printf("[%s] %s\n",filename,list_line);
  tree_add(&t,list_line,(void *)1);//je jedno co se tam da, neni dulezita hodnota, ale to ze tam prvek je
  free(list_line);
 }
 debug_printf("%s loaded\n",filename);
 free(list_data);
 return t;
}

/** nahraje konfiguraci ze souboru file */
config *load_config(char *filename) {
 config *cfg;//konfiguracni data
 int cfg_size;//velikost konfiguraku
 char *cfg_data;//konfigurak nacteny v pameti
 char *cfg_key;//Vyparsovany klic
 char *cfg_value;//Vyparsovany klic
 text_token conf;//konfigurak v pameti v parsovatelnem tokenu

 //alokuj konfiguraci, nastav default data
 cfg=malloc0(sizeof(config));
 cfg->pop3_port=110;
 cfg->smtp_port=25;
 cfg->refcount=0;
 cfg->blacklist_level=100;
 cfg->whitelist_level=0;

 //nahraj soubor, zacni parsovat
 cfg_size=loadfile((void **)(&cfg_data),filename);
 if (!cfg_data) fatalf("Can't load config file %s",filename);
 if (!cfg_size) fatalf("Empty config file %s",filename);
 conf=token_create(cfg_data,cfg_size);
 while(token_readkv(&conf,&cfg_key,&cfg_value)) {
  debug_printf("KEY: %s =  VALUE: %s\n",cfg_key,cfg_value);//debug
       if (eqi(cfg_key,"pop3_port"))		cfg->pop3_port=atoi(cfg_value);
  else if (eqi(cfg_key,"smtp_port"))		cfg->smtp_port=atoi(cfg_value);
  else if (eqi(cfg_key,"blacklist-level"))	cfg->blacklist_level=atoi(cfg_value);
  else if (eqi(cfg_key,"whitelist-level"))	cfg->whitelist_level=atoi(cfg_value);
  else if (eqi(cfg_key,"classification"))	cfg->p_class=strdup(cfg_value);
  else if (eqi(cfg_key,"smtp_server"))		cfg->remotesmtp=strdup(cfg_value);
  else if (eqi(cfg_key,"blacklist"))		cfg->blacklistfile=strdup(cfg_value);
  else if (eqi(cfg_key,"whitelist"))		cfg->whitelistfile=strdup(cfg_value);
  else if (eqi(cfg_key,"post-action"))		plist_add(&cfg->p_postact,cfg_value);
  else if (eqi(cfg_key,"post-filter"))		plist_add(&cfg->p_postfilt,cfg_value);
  else if (eqi(cfg_key,"classify-filter"))	plist_add_num(&cfg->p_prefilt,0,0,cfg_value);
  else if (eqi(cfg_key,"mark-subject"))		plist_add(&cfg->subject_mark,cfg_value);
  else fatalf("Unknown key in config file: %s",cfg_key);
  free(cfg_key);//uvolni i cfg_value
 }
 free(cfg_data);

 debug_printf ("loading lists\n");
 //nahrani blacklistu/whitelistu
 if (!empty(cfg->blacklistfile)) cfg->blacklist=loadlist(cfg->blacklistfile);
 if (!empty(cfg->whitelistfile)) cfg->whitelist=loadlist(cfg->whitelistfile);
 debug_printf ("loaded lists\n");

 lock_config_int(cfg);//bez zamykani (tady ani nema smysl, pac ta struktura jeste nevysla ven)
 return cfg;
}

pthread_mutex_t cfg_lock;//lock na manipulace s configem

/** inicializace zamku */
void config_mutex_lock_init() {
 pthread_mutex_init(&cfg_lock, NULL);
}

/** zamkne konfiguraci pro modifikace */
void config_mutex_lock() {
 //printf("c_lock\n");
 pthread_mutex_lock(&cfg_lock);
}

/** odemkne konfiguraci pro modifikace */
void config_mutex_unlock() {
 //printf("c_unlock\n");
 pthread_mutex_unlock(&cfg_lock);
}


/** zvysi refcount */
config *lock_config(config *c) {
 config_mutex_lock();
 if (!c) c=active;
 c->refcount++;
 config_mutex_unlock();
 return c;
}

/** zvysi refcount (bez zamykani) */
config *lock_config_int(config *c) {
 if (!c) c=active;
 c->refcount++;
 return c;
}

/** snizi refcount, eventuelne zlikviduje strukturu */
void unlock_config(config *c) {
 config_mutex_lock();
 if (!c) c=active;
 unlock_config_int(c);
 config_mutex_unlock();
}

/** snizi refcount, eventuelne zlikviduje strukturu (bez zamykani) */
void unlock_config_int(config *c) {
 c->refcount--;
 if (!c->refcount) {
  free_config(c);
 } 
}

void main_rebind(int change_smtp,int change_pop3);//funkce v hlavnim programu, ktera zmeni porty na kterych se nasloucha

/** sighup handler: reload config */
void sighup_handler(int sig) {
 int smtpp,pop3p;//stare porty
 config *cfg;
 //printf("sigHUP received\n");
 config_mutex_lock();
 cfg=load_config(configfile);
 smtpp=active->smtp_port;
 pop3p=active->pop3_port;
 unlock_config_int(active);
 //printf("cfg: %x->%x\n",(int)active,(int)cfg);
 active=cfg;
 if (smtpp!=active->smtp_port || pop3p!=active->pop3_port) {
  //prehazi sockety v hlavnim programu, pokud se listenuje na novych portech ....
  main_rebind(smtpp!=active->smtp_port,pop3p!=active->pop3_port);
 }
 config_mutex_unlock();
 //printf("sigHUP finished\n");
}

/** uvolni konfiguracni strukturu z pameti*/
void free_config(config *c) {
 str_free(c->blacklistfile);
 str_free(c->whitelistfile);
 tree_free(c->blacklist);
 tree_free(c->whitelist);
 str_free(c->p_class);
 plist_free(c->p_prefilt);
 plist_free(c->p_postfilt);
 plist_free(c->p_postact);
 plist_free(c->subject_mark);
 free(c);
}

/** odalokuje spojak s programy spoustenymi dle priorit */
void plist_free(priority_list *p) {
 priority_list *px;
 while (p) {
  px=p->next;
  free(p->prog);
  free(p);
  p=px;
 }
}

/** do prioritniho seznamu prida zaznam z konfiguraku (format "LOW-HIGH PROGRAM"/"PRIO PROGRAM") */
void plist_add(priority_list **p,char *cfg_line) {
 int lo,hi,res;
 char *prog;
 res=sscanf(cfg_line,"%d-%d ",&lo,&hi);
 if (res!=2) {
  res=sscanf(cfg_line,"%d ",&lo);
  if (res==1) hi=lo;
  else fatalf("Invalid/missing priority in priority list (%s)",cfg_line);
 }
 prog=cfg_line;
 while (prog[0] && (!is_space(prog[0]))) prog++;
 while (prog[0] && (is_space(prog[0]))) prog++;//preskocit taky mezery
 if (empty(prog)) fatalf("Empty program in priority list (%s)",cfg_line);
 plist_add_num(p,lo,hi,prog);
}

/** do prioritniho seznamu prida zaznam z konfiguraku (LOW,HIGH,PROGRAM) */
void plist_add_num(priority_list **p,int lo, int hi, char *prog) {
 priority_list *px;
 if (empty(prog)) fatalf("Empty program in program list");
 while(*p) p=&((*p)->next);//postoupime na posledni zaznam
 px=malloc1(sizeof(priority_list));
 px->next=NULL;
 px->min=lo;
 px->max=hi;
 px->prog=strdup(prog);
 *p=px;//pridame na konec seznamu
}
@


1.5
log
@*** empty log message ***
@
text
@d1 1
d5 1
d19 1
a19 1

d22 1
d26 1
a26 1
//  printf("[%s] %s\n",filename,list_line);
d30 1
d55 2
a56 1
 if (!cfg_size) fatalf("Empty config file e);
d58 1
a58 1
//  printf("KEY: %s =  VALUE: %s\n",cfg_key,cfg_value);//debug
d76 1
d80 1
d95 1
a95 1
 printf("c_lock\n");
d101 1
a101 1
 printf("c_unlock\n");
d138 2
d142 1
d144 1
a144 1
 printf("sigHUP received\n");
d147 2
d150 1
a150 1
 printf("cfg: %x->%x\n",(int)active,(int)cfg);
d152 4
a155 1
 //TODO: prehazet sockety v hlavnim programu, pokud se listenuje na novych portech ....
d157 1
a157 1
 printf("sigHUP finished\n");
d196 2
a197 1
 while (prog[0] && !(is_space(prog[0]))) prog++;
@


1.4
log
@*** empty log message ***
@
text
@d35 2
a36 1
 char *cfg_data;//konfigurak nacteny v p klic
@


1.3
log
@*** empty log message ***
@
text
@d31 1
a31 1
/** nahraje konfigu raci ze souboru file */
d76 1
a76 1
 lock_config(cfg);
d89 1
d95 1
d109 7
d135 1
d139 1
d143 1
d191 1
a191 1
 while(*p) *p=(*p)->next;//postoupime na posledni zaznam
@


1.2
log
@*** empty log message ***
@
text
@d4 1
d124 1
a124 1
void sighup_handler() {
d170 1
a170 1
 while (prog[0] && prog[0]!=' ') prog++;
@


1.1
log
@Initial revision
@
text
@d2 27
d44 2
d48 1
a48 1
 cfg_size=loadfile((void **)&cfg_data,filename);
d50 1
d53 13
a65 8
  printf("KEY: %s =  VALUE: %s\n",cfg_key,cfg_value);//debug
       if (eqi(cfg_key,"pop3_port")) cfg->pop3_port=atoi(cfg_value);
  else if (eqi(cfg_key,"smtp_port")) cfg->smtp_port=atoi(cfg_value);
  else if (eqi(cfg_key,"classification")) cfg->p_class=strdup(cfg_value);
  else if (eqi(cfg_key,"smtp_server")) cfg->remotesmtp=strdup(cfg_value);
  else if (eqi(cfg_key,"blacklist")) cfg->blacklistfile=strdup(cfg_value);
  else if (eqi(cfg_key,"whitelist")) cfg->whitelistfile=strdup(cfg_value);

a66 7

/*post-action=50-100 /usr/bin/send_false_reply {from} {to} {subj}
post-filter=0-20 /usr/bin/posli_info_na_mobil
classification-filter=/usr/bin/sp_class_filter
mark-subject=80-100 [SPAM]
*/
  //TODO: apply key/value to config
d71 3
a73 1
//TODO: load blacklist/whitelist
d79 18
d98 3
a100 1
void lock_config(config *c) {
d102 2
d108 8
d122 11
d135 2
a136 2
 free(c->blacklistfile);
 free(c->whitelistfile);
d139 1
a139 1
 free(c->p_class);
a146 6
/** aplikuje konfiguraci newc, starou konfiguraci oldc zahodi */
void apply_config(config *oldc, config *newc) {
//TODO
 unlock_config(oldc);
}

d152 1
d156 29
@
