use POSIX qw(strftime);
use strict;

#settings
my $lang="cz";
my $make_todo=0;

my $run_date=strftime "%d.%m.%Y %H:%M:%S", localtime;

my $htmldir='html';
my $htmlext='htm';
my $stylename='q.css';

#language
my %alang=();
my $allfiles="All files";
my $files="Files";
my $sdoc="source documentation";
my $doc4file="Documentation for file";
my $docall="Documentation for all files";
my $docdate='Documentation from';
$alang{'maincomment'}="File description";
$alang{'type'}="Types";
$alang{'var'}="Variables";
$alang{'const'}="Constants";
$alang{'function'}="Functions";
$alang{'todo'}="TODO list";
if ($lang eq 'cz') {
 $allfiles="Vechny soubory";
 $files="Soubory";
 $sdoc="Dokumentace zdrojovch kd";
 $doc4file="Dokumentace k souboru";
 $docall="Dokumentace pro vechny soubory";
 $docdate='Dokumentace z';
 $alang{'maincomment'}="Popis souboru";
 $alang{'type'}="Typy";
 $alang{'var'}="Promnn";
 $alang{'const'}="Konstanty";
 $alang{'function'}="Funkce";
 $alang{'todo'}="Vci co je NUTN vyeit";
}

my $html_pre1="<!doctype html public \"-\/\/w3c\/\/dtd html 4.0 transitional\/\/en\"><html><head><link rel=stylesheet href=$stylename><meta http-equiv=\"Content-type\" content=\"text/html; charset=windows-1250\"><title>";
my $html_pre2="</title></head><body bgcolor=#000060 text=#ffffee link=#99ff99 vlink=#66ee66>";
my $html_post="</body></html>";
my $table_head=" bgcolor=#0000aa";
my $table_begin=" cellpadding=4 cellspacing=0 border=0";

my %files=();
my %types=();
my %types_f=();
my %elem=();
my @elems;

if ($make_todo) {
 @elems=split(/,/,'maincomment,todo,type,const,var,function');
} else {
 @elems=split(/,/,'maincomment,type,const,var,function');
}

sub save {
 my ($s,$name)=@_;
 print("Writing $name ...\n");
 open(D, ">".$name) || return 0;
 print D $s;
 close D ||return 0;
 return 1;
}
sub mfile {
 my ($s)=@_;
 $s=~s/[\\]\?\*\//_/g;
 return $s;
}

while (<>) {
 my @q=split(/:/,$_);
 my $type=$q[0];
 my $file=$q[1];
 my $id=$q[2];
 if ($id eq '') {$id=$file;}
 $types{$type}=1;
 $types_f{$file}{$type}=1;
 $files{$file}=mfile($file);
 $elem{$id}=$_;
}

my $lf='';

sub nicename {
 my ($e)=@_;
 if ($e=~/maincomment|type|var|const|function|todo/) {return $alang{$e};}
 return "?$e?";
}

sub filecheck {
 my ($e,$f)=@_;
 if ($e eq '') {return 1;}
 if ($e eq $f) {return 1;}
 return 0;
}

sub out_one {
 my (@e)=@_;
 my $type=$e[0];
 my $c=$e[2];
 my $td="td valign=top";
 my $filex='';
 $c=~s/<!--[^>]*-->//g;
 $c="<font color=#ffffbb><b>$c</b></font>";
 if ($type eq 'type') {
  return "<tr>$filex<$td>$c</td><$td>$e[3]</td><$td>$e[4]</td></tr>\n";
 } elsif ($type eq 'var') {
  return "<tr>$filex<$td>$c</td><$td>$e[3]</td><$td>$e[4]</td><$td>$e[5]</td></tr>\n";
 } elsif ($type eq 'const') {
  return "<tr>$filex<$td>$c</td><$td>$e[3]</td><$td>$e[4]</td></tr>\n";
 } elsif ($type eq 'todo') {
  return "<tr>$filex<$td>$c</td><$td>$e[3]</td></tr>\n";
 } elsif ($type eq 'maincomment') {
  return "<tr>$filex<$td>$e[2]</td></tr>\n";
 } elsif ($type eq 'function') {
  $e[4]=~s/ /&nbsp;/g;
  return "<tr>$filex<$td>$e[4]</td><$td>$c</td><$td>$e[3]</td><$td>$e[5]</td></tr>\n";
 }
 return "$c<br>\n";
}
sub header {
 my ($e)=@_;
 my $nn=nicename($e);
 my $c="<a name=\"#$e\"></a><h1>$nn (&P)</h1>\n<table $table_begin>";
 my $filex='';
 my $add='';
 my $addb="<tr $table_head>$filex<td>";
 my $adde="</td></tr>";
 my $addi='';
 if ($e eq 'maincomment') {$add='';}
 if ($lang eq 'cz') {
  if ($e eq 'type')    {$addi="Jmno,Definice,Dokumentace";}
  if ($e eq 'var')     {$addi="Jmno,Typ,Poten hodnota,Dokumentace";}
  if ($e eq 'const')   {$addi="Jmno,Hodnota,Dokumentace";}
  if ($e eq 'function'){$addi="Modifiktor,Jmno,Parametry,Dokumentace";}
  if ($e eq 'todo')    {$addi="Kde,Co";}
 } else {
  if ($e eq 'type')    {$addi="Name,Definition,Documentation";}
  if ($e eq 'var')     {$addi="Name,Type,Initial value,Documentation";}
  if ($e eq 'const')   {$addi="Name,Value,Documentation";}
  if ($e eq 'function'){$addi="Modifiers,Name,Parameters,Documentation";}
  if ($e eq 'todo')    {$addi="Where,What";}
 }
 if ($addi=~/./) {
  $addi=join("</td><td>",split(",",$addi));
  $add="$addb$addi$adde";
 }
 return "$c$add";
}

sub ehead {
 my ($e)=@_;
 my $nn=nicename($e);
 return "<a href=\"#$e\">$nn</a>";
}

sub htmlize {
 my ($title,$c)=@_;
 my $ntitle='';
 if (!($title eq '')) {
  $ntitle="<h2>".$title."</h2>";
 }
 return $html_pre1.$title.$html_pre2.$ntitle.$c.$html_post;
}

sub makefile {
 my ($e,$f)=@_;
 my $c='';
 my %typ;
 my @elemhead=();
 if ($f eq '') {
  %typ=%types;
 } else {
  %typ=%types;#_f{$e};
 }
# foreach my $type(keys %typ) {
 foreach my $type(@elems) {
  if ($typ{$type}=~/./ && !(($type eq 'maincomment') && ($f eq ''))) {
   my $c2b=header($type);
   my $c2='';
   my $c2o=0;
   foreach my $name(sort keys %elem) {
    my @el=split(/:/,$elem{$name});
    if (filecheck($f,$el[1]) and ($type eq $el[0])) {
     $c2.=out_one(@el);
     $c2o++;
    }
   }
   $c2b=~s/&P/$c2o/;
   $c2=$c2b.$c2;
   if ($c2o) {
    $c.=$c2;
    $c.="</table>\n";
    push (@elemhead,ehead($type));
   }
  }
 }
 my $title="$doc4file $f";
 if ($f eq '') {$title=$docall;}
 $c=(join(' | ',@elemhead)).$c;
 $c=htmlize($title,$c."<hr color=#000080>$docdate $run_date");
 save($c,$htmldir."/$e"); 
}

my $h_files="<b>$files</b><br>";
mkdir($htmldir);
foreach my $f(sort keys %files) {
 my $ff=$files{$f};
 $h_files.="&nbsp;&nbsp;<a href=$ff.$htmlext target=b>$f</a><br>\n";
 makefile("$ff.$htmlext",$f);
}
$h_files.="&nbsp;&nbsp;<a href=all.$htmlext target=b>$allfiles</a><br>\n";
makefile("all.$htmlext",'');
$h_files=htmlize("",$h_files);
save($h_files,$htmldir."/content.$htmlext"); 
my $indexf="<frameset cols=\"120,*\" framespacing=0 border=0 frameborder=no><frame name=a src=content.$htmlext scrolling=auto marginwidth=0 noresize><frame name=b src=all.$htmlext scrolling=auto marginwidth=0 noresize></frameset>";
$indexf=$html_pre1."$sdoc</title></head>".$indexf.$html_post;
save($indexf,$htmldir."/index.$htmlext"); 
open(Q, "<$stylename");
my $stylesheet='';
while (<Q>) {
 $stylesheet.=$_;
}
close(Q);
save($stylesheet,$htmldir."/$stylename"); 
print "Done.\n";