#include <stdlib.h>
#include <stdarg.h>

//binarni vyhledavaci strom. Jako klic je pouzit retezec, obsahuje hodnoty typu (void *)
typedef struct _tree {
 int num;		//pocet prvku tohoto (pod)stromu
 char *name;		//jmeno
 void *val;		//hodnota
 struct _tree *l,*r;    //levy a pravy podstrom
} tree;

typedef struct {// Struktura pro praci s textem. Pouzivana hlavne pri nahravani textovych souboru (jako napr. .map nebo .def)
 char *begin;//zacatek
 char *curr; //aktualni pozice
 int left;   //kolik bajtu zbyva;
} text_token;

typedef void tree_func(char *name,void *s);
typedef void tree_func_p(char *name,void *s,void *param);

#define token_move(t,i) (t)->left-=i;(t)->curr+=i //posune kurzor v tokenu t o i mist dale
#define token_beginwith(t,w) (((t)->left>0) && (t)->curr[0]==(w)) //prvni znak tokenu
#define token_whitespace(t) (((t)->left>0) && isseparator((t)->curr[0])) //prvni znak tokenu
#define token_readkv(t,k,v) token_readkv_sep(t,k,v,'=') //makro na token_readkv_sep s defaultnim separatorem
#define token_create_dynamic(t,source,size) (t)=malloc1(sizeof(text_token));(t)->begin=(t)->curr=source;(t)->left=(size)

// konec tadky
#define eol(t) ((t)=='\r' || (t)=='\n' || (t)==0)

// true pokud je znak whitespace (mezera, tabulator) ale ne newline
#define is_space(x) (((x)==' ')||((x)=='\t'))

// true pokud je znak whitespace (mezera, tabulator, newline ...)
#define isseparator(x) (is_space(x)||newline(x))

// true pokud je znak newline (cr nebo lf)
#define newline(x) (((x)==13)||((x)==10))

#define stricmp strcasecmp	//alias pro funkci
#define strnicmp strncasecmp	//alias pro funkci
#define _vsnprintf vsnprintf	//alias pro funkci

#ifndef max
#define max(a,b) (((a)>(b))?(a):(b)) 	//maximum ze 2 cisel
#endif
